#include <stdlib.h>
#include <stdio.h>

int CompareStage(FILE*,FILE*),PatchStage(FILE*,FILE*);
int ProcOneLine(char*,FILE*);
#define MAXLINELEN 2048
char GCB0[MAXLINELEN],GCB1[MAXLINELEN],PFINFO[2048],PFWARN[2048];
char StartUpMessage[]={"\nFile Patcher v0.1 by Bo Yang\n"};
int main(int argc,char**argv)
{FILE*lstf,*patf;
 int PatCnt=0;

 puts(StartUpMessage);
 if (argc<3)  { puts("usage: patchit patch-data-file file-to-be-patched"); return(1); }

 lstf=fopen(argv[1],"rb");
 if (lstf==NULL) { puts("can't open data-file"); return(2); }
 fread(GCB0,32,1,lstf);
 if (GCB0[0]!='B' || GCB0[1]!='Y' || GCB0[2]!='P' || GCB0[3]!='D') {
   puts("bad patch-data-file"); fclose(lstf); return(10);
 }
 fread(PFINFO,2048,1,lstf); puts(PFINFO);
 fread(PFWARN,2048,1,lstf);
 if (CheckUserKey()) { fclose(lstf); return(4); }
 patf=fopen(argv[2],"r+b");
 if (patf==NULL) { fclose(lstf); puts("can't open target-file"); return(3); }
 putch('\n');
 if (CompareStage(lstf,patf)) {
   puts(PFWARN);
   if (CheckUserKey()) { fclose(lstf); fclose(patf); return(5); }
 }
 PatchStage(lstf,patf);
 puts("\nDone.");
 fclose(lstf); fclose(patf); return(0);
}

PatchStage(FILE*lstf,FILE*patf)
{int CmpCnt;
 long dstOffset,blkSize;

 fread((char*)&CmpCnt,2,1,lstf);
 while (CmpCnt--) {
   fread((char*)&dstOffset,4,1,lstf);
   fread((char*)&blkSize,4,1,lstf);
   fseek(patf,dstOffset,0);
   while (blkSize>=MAXLINELEN) {
     blkSize-=MAXLINELEN;
     fread(GCB0,MAXLINELEN,1,lstf);
     fwrite(GCB0,MAXLINELEN,1,patf);
   }
   if (blkSize) {
     fread(GCB0,(int)blkSize,1,lstf);
     fwrite(GCB0,(int)blkSize,1,patf);
   }
 }
 return(0);
}

CompareStage(FILE*lstf,FILE*patf)
{int RetVal=0,CmpCnt;
 long dstOffset,blkSize;

 fread((char*)&CmpCnt,2,1,lstf);
 while (CmpCnt--) {
   fread((char*)&dstOffset,4,1,lstf);
   fread((char*)&blkSize,4,1,lstf);
   if (RetVal) fseek(lstf,blkSize,1);
   else { //if not already different
     fseek(patf,dstOffset,0);
     while (blkSize>=MAXLINELEN) {
       blkSize-=MAXLINELEN;
       fread(GCB0,MAXLINELEN,1,lstf);
       fread(GCB1,MAXLINELEN,1,patf);
       if (memcmp(GCB0,GCB1,MAXLINELEN)) {
         fseek(lstf,blkSize,1);
         RetVal=1; blkSize=0;
       }
     }
     if (blkSize) {
       fread(GCB0,(int)blkSize,1,lstf);
       fread(GCB1,(int)blkSize,1,patf);
       if (memcmp(GCB0,GCB1,(int)blkSize)) RetVal=1;
     }
   }
 }
 return(RetVal);
}

CheckUserKey()
{int key0;
BRgetkey: _asm xor ax,ax
 _asm int 22
 _asm mov key0,ax
 if (key0==0x11b) return(1);
 key0&=255;
 if (key0=='n' || key0=='N') return(1);
 if (key0!='y' && key0!='Y') goto BRgetkey;
 return(0);
}
